{***************************************************************************
                       cloxten.dpr   -  Cloxten main file.
                             -------------------
    copyright            : (C) 2002 Alberto Lohmann
    email                : lohmann@users.sourceforge.net
    app. url             : http://cloxten.sourceforge.net
    project url          : http://sourceforge.net/projects/cloxten
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************}

// * This file is part of Cloxten program.



program cloxten;

uses
  QForms,
  SysUtils,
  QDialogs,
  mainform in 'mainform.pas' {Form1},
  optionsform in 'optionsform.pas' {Form2},
  reminder in 'reminder.pas' {Form3},
  forks in 'forks.pas',
  data in 'data.pas',
  mail in 'mail.pas' {Form4};

{$E bin}

var
  i: Integer;

{$R *.res}

begin
  writeln('Cloxten version 0.1.2 Pre-Alpha, Copyright (C) 2002 Alberto Lohmann');
  writeln('This is a free software and comes with ABSOLUTELY NO WARRANTY;');
  writeln('for details see http://cloxten.sourceforge.net/');

  for i := 1 to ParamCount do
  begin
    if LowerCase(ParamStr(i)) = '-h' then begin
      writeln(' ');
      writeln('Usage  : cloxten [-ns -d "directory"]');
      writeln('         cloxten -h');
      writeln(' ');
      writeln('options: -ns  : Do not show initial window.');
      writeln('         -h   : Show this message and exit.');
      writeln('         -d   : Especify where Cloxten must create a hidden ' +
              'directory to record');
      writeln('                and read configuration files. Usually, ' +
              'the user home directory.');
      writeln('                If not used, $HOME directory will be choosen.');
      writeln(' ');
      exit;
    end;
    if ParamStr(i) = '-d'
      then Data.HOME_DIR := ParamStr(i+1); // Get Cloxten HOME to work.
  end;

  Application.Initialize;

  if Data.HOME_DIR = EmptyStr                            // if empty,
    then Data.HOME_DIR := GetEnvironmentVariable('HOME');// get user home dir

  if DirectoryExists(Data.HOME_DIR) = False then begin
    Showmessage(
      'Directory ' + Data.HOME_DIR + ' does not exist or you do not have ' +
      'write permission in it. Cloxten will exit.');
    Application.Terminate;
  end
  else begin
    Application.CreateForm(TForm1, Form1);
    Application.CreateForm(TForm2, Form2);
    Application.CreateForm(TForm3, Form3);
    Application.CreateForm(TForm4, Form4);
    TData.Create.CheckFiles;// Check if config file exists or create it if not.
    if Data.CONFIG_EXISTS = True
      then TData.Create.RetrieveData;

    { Message procedures. }
    Form2.GetTempMailStrs; //
    Form2.TaskStatus; //

    { After all is done. }
    Form1.Visible := True;
    Application.Run;
  end;
end.
