{***************************************************************************
                      forks.pas   -  Children processes.
                             -------------------
    copyright            : (C) 2002 Alberto Lohmann
    email                : lohmann@users.sourceforge.net
    app. url             : http://cloxten.sourceforge.net
    project url          : http://sourceforge.net/projects/cloxten
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************}

// * This file is part of Cloxten program.



unit forks;

interface

uses
  {$IFDEF LINUX} Libc {$ENDIF},
  QControls,
  QDialogs,
  SysUtils;

type
  TForks = class
    procedure Actions;
    procedure ExecFile;
    procedure Execute;
    procedure PlayFile;
    procedure SendMsg;
  end;

var
  pid: PID_T;
  parg: array[0..9] of PChar;
  MsgStatus: integer; { 0 = sent or initial value; 1 = canceled }
  MAIL_BIN: String = 'mutt'; { The Mutt Mail User Agent }
  TEXT_FORMATTER_BIN: String = 'fmt'; { simple optimal text formatter }

implementation

uses optionsform, mainform, reminder, data, mail;

procedure TForks.Actions;
begin
  if Form2.CheckBox2.Checked = True then begin
    if Form2.RadioButton1.Checked = True then QControls.Beep;
    if Form2.RadioButton2.Checked = True then PlayFile;
  end;
  if Form2.RadioButton3.Checked = False then begin // Only if unchecked.
    if Form2.RadioButton4.Checked = True then SendMsg;
    if Form2.RadioButton5.Checked = True then ExecFile;
  end;
  
  { After all is done. }
  if Form2.CheckBox1.Checked = True then begin
    Form3.ShowEventsAndTasks;
    Form3.Tag := 0;
    Form3.ShowModal;
  end;
  if Form2.CheckBox5.Checked = True then begin
    if Form2.CheckBox1.Checked = True
      then Form1.Hide
      else Form1.Close;
  end;
end;

procedure TForks.ExecFile;
begin
  parg[0] := PChar(optionsform.FileToRun);
  parg[1] := nil;

  Execute;
end;

procedure TForks.Execute;
var
  i: integer;
  
begin
  pid := fork;
  if pid = 0 then begin
    if execvp(parg[0],PPChar(@parg[0])) = -1 then begin
      writeln('cloxten: Can''t execute ' + parg[0]);
      _Exit(-1);
    end;
  end;

  for i := 0 to 9 do parg[i] := nil; //Clear all args pointers.
end;

procedure TForks.PlayFile;
begin
//
end;

procedure TForks.SendMsg;
begin
  MsgStatus := 0;

  if Form4.CheckBox1.Checked = True then begin
    if MessageDlg('A message was posted to "' + Form4.Edit2.Text
                + '", subject "' + Form4.Edit5.Text
                + '", but you ask me to remind you before send it.'
                + ' Do you want to send it?',
      mtConfirmation, [MbYes, MbNo], 0, MbYes) = mrYes
      then MsgStatus := 0
      else MsgStatus := 1;
  end;
  
  if MsgStatus = 0
    then Libc.system(PChar(TEXT_FORMATTER_BIN + ' ' + Data.HOME_DIR +
                           '/.cloxten/mail.txt | ' + MAIL_BIN + ' ' +
                           optionsform.MsgArgsStr));
end;

end.

