{***************************************************************************
                       mail.pas   -  mail window form.
                             -------------------
    copyright            : (C) 2002 Alberto Lohmann
    email                : lohmann@users.sourceforge.net
    app. url             : http://cloxten.sourceforge.net
    project url          : http://sourceforge.net/projects/cloxten
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************}

// * This file is part of Cloxten program.



unit mail;

interface

uses
  {$IFDEF LINUX} Libc {$ENDIF},
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls, QStdCtrls, QButtons, QActnList;

type
  TForm4 = class(TForm)
    Memo1: TMemo;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Panel1: TPanel;
    Label6: TLabel;
    BitBtn4: TBitBtn;
    OpenDialog1: TOpenDialog;
    CheckBox1: TCheckBox;
    ListBox1: TListBox;
    ActionList1: TActionList;
    F1_ShowContents: TAction;
    procedure FormShow(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure OpenDialog1Close(Sender: TObject);
    procedure OpenDialog1FileAdd(Sender: TObject; const Filename: String;
      const Readable, Writeable, Executable: Boolean; var CanAdd: Boolean);
    procedure ChangedMail;
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure MsgIsOK;
    procedure MsgIsNotOK;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Public declarations }
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

uses
  data, optionsform, mainform, forks;

{$R *.xfm}

procedure TForm4.FormShow(Sender: TObject);
begin
  Edit5Change(Sender); { Update Form Caption. }
  Edit1.Text := GetEnvironmentVariable('USER') + '@'
                + GetEnvironmentVariable('HOSTNAME');
  Edit2.SetFocus;

  Form4.Tag := 0; { Initial status: No change. }
end;

procedure TForm4.Edit5Change(Sender: TObject);
begin
  if Form4.Visible = True then begin
    ChangedMail;
    if Edit5.Text = ''
      then Caption := '(unnamed) - Cloxten'
      else Caption := Edit5.Text + ' - Cloxten';
  end;
end;

procedure TForm4.BitBtn2Click(Sender: TObject);
begin
  if Form4.Tag = 1 then begin
    if MessageDlg('Message has been modified. Close without save?',
    mtConfirmation, [MbYes, MbNo], 0, MbNo) = mrYes
    then begin
      //Form4.Close;
      if Form2.RadioButton4.Tag = 0
        then Form2.SetTempMailStrs
        else Form2.ClearMailCache;
      Form4.Close;//
    end;
  end
  else begin
    //Form4.Close;
    if Form2.RadioButton4.Tag = 0
      then Form2.SetTempMailStrs
      else Form2.ClearMailCache;
    Form4.Close;//
  end;


  
{  if Form4.Tag = 1 then begin
    if MessageDlg('Message has been modified. Close without save?',
    mtConfirmation, [MbYes, MbNo], 0, MbNo) = mrYes
    then begin
      if Form2.RadioButton4.Tag = 0
        then Form2.SetTempMailStrs
        else Form2.ClearMailCache;
      Form4.Close;
    end;
  end
  else begin
    if Form2.RadioButton4.Tag = 0
      then Form2.SetTempMailStrs
      else Form2.ClearMailCache;
    Form4.Close;
  end; }
end;

procedure TForm4.BitBtn1Click(Sender: TObject);
begin
  if (Edit2.Text <> '') and (Memo1.Lines.Text <> '') then begin
    if Edit5.Text = '' then begin
      if MessageDlg('This message has no subject. Continue?',
        mtConfirmation, [MbYes, MbNo], 0, MbNo) = mrYes
        then begin
          Form2.GetTempMailStrs;//
          MsgIsOK;
        end;
    end
    else begin
      Form2.GetTempMailStrs;//
      MsgIsOK;
    end
  end
  else MsgIsNotOK;
end;

procedure TForm4.BitBtn4Click(Sender: TObject);
begin
  OpenDialog1.Execute;
end;

procedure TForm4.OpenDialog1Close(Sender: TObject);
begin
  if SysUtils.FileExists(OpenDialog1.FileName) = False
    then OpenDialog1.FileName := ''
    else begin
      if Memo1.Text <> '' then begin
        if MessageDlg('This will clear all entries in current message text. Continue?',
        mtConfirmation, [MbYes, MbNo], 0, MbNo) = mrYes
        then Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
      end
      else Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
    end;
end;

procedure TForm4.OpenDialog1FileAdd(Sender: TObject;
  const Filename: String; const Readable, Writeable, Executable: Boolean;
  var CanAdd: Boolean);
begin
  if Readable = True then CanAdd := True;
end;

procedure TForm4.ChangedMail;
begin
  Form4.Tag := 1; { 0 = no change; 1 = Changed }
end;

procedure TForm4.Edit2Change(Sender: TObject);
begin
  if Form4.Visible = True then ChangedMail;
end;

procedure TForm4.Edit3Change(Sender: TObject);
begin
  if Form4.Visible = True then ChangedMail;
end;

procedure TForm4.Edit4Change(Sender: TObject);
begin
  if Form4.Visible = True then ChangedMail;
end;

procedure TForm4.Memo1Change(Sender: TObject);
begin
  if Form4.Visible = True then ChangedMail;
end;

procedure TForm4.MsgIsOK;
begin
  if Form4.Tag = 1
    then begin
      SysUtils.RenameFile(Data.HOME_DIR + '/.cloxten/mail.txt',
                          Data.HOME_DIR + '/.cloxten/mail.tmp');
      Form4.Memo1.Lines.SaveToFile(Data.HOME_DIR + '/.cloxten/mail.txt');
    end;
  Form4.Close; { Everything is OK to send msg. }
end;

procedure TForm4.MsgIsNotOK;
begin
  if (Edit2.Text = '') and (Memo1.Lines.Text = '')
    then ShowMessage('Can''t send without addressee and body message.')
  else if (Edit2.Text = '') and (Memo1.Lines.Text <> '')
    then ShowMessage('Can''t send without addressee.')
  else ShowMessage('Can''t send without body message.');
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  Form2.GetTempMailStrs;
end;

procedure TForm4.BitBtn3Click(Sender: TObject);
begin
  Form1.FindHelpBin;

  if Forks.parg[0] <> nil then begin
    Forks.parg[1] := PChar('-mc');
    Forks.parg[2] := PChar('-ns');
    Forks.parg[3] := nil;
    TForks.Create.Execute;
  end;
end;

end.

