{***************************************************************************
                       mainform.pas   -  Cloxten Main form.
                             -------------------
    copyright            : (C) 2002 Alberto Lohmann
    email                : lohmann@users.sourceforge.net
    app. url             : http://cloxten.sourceforge.net
    project url          : http://sourceforge.net/projects/cloxten
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************}

// * This file is part of Cloxten program.



unit mainform;

interface

uses
  Classes,
  {$IFDEF LINUX} Libc {$ENDIF},
  QActnList,
  QButtons,
  QComCtrls,
  QControls,
  QDialogs,
  QExtCtrls,
  QForms,
  QGraphics,
  QMenus,
  QStdCtrls,
  QTypes,
  SysUtils,
  Types,
  Variants, QStdActns;

type
  TForm1 = class(TForm)
    LCDNumber1: TLCDNumber;
    Label1: TLabel;
    Label2: TLabel;
    RadioGroup1: TRadioGroup;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    CheckBox1: TCheckBox;
    Label6: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    BitBtn4: TBitBtn;
    Timer1: TTimer;
    RadioGroup2: TRadioGroup;
    CheckBox2: TCheckBox;
    PopupMenu1: TPopupMenu;
    Actions1: TMenuItem;
    Basic1: TMenuItem;
    Advanced1: TMenuItem;
    Settings1: TMenuItem;
    Alarm1: TMenuItem;
    Counter1: TMenuItem;
    General1: TMenuItem;
    StatusBar1: TStatusBar;
    N1: TMenuItem;
    NoWarranty1: TMenuItem;
    About1: TMenuItem;
    N2: TMenuItem;
    Close1: TMenuItem;
    Help1: TMenuItem;
    Information1: TMenuItem;
    COPYING1: TMenuItem;
    ActionList1: TActionList;
    F1_HelpContents: THelpContents;
    Alarm: TAction;
    Counter: TAction;
    F5_PopUpMenuCalls: TAction;
    F3_Close: TAction;
    F2_ShowToDoList: TAction;
    F4_ShowControlWindow: TAction;
    ToDolist1: TMenuItem;
    procedure BitBtn2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Label6MouseEnter(Sender: TObject);
    procedure Label6MouseLeave(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure ComboBoxesChange;
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure CountDown;
    procedure ProgressiveCount;
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox1OnChange;
    procedure DisabBody;
    procedure EnabBody;
    procedure DisplayAll;
    procedure Start;
    procedure Pause;
    procedure Restart;
    procedure BitBtn4Click(Sender: TObject);
    procedure Timer12hs;
    procedure Timer24hs;
    procedure CheckBox2Click(Sender: TObject);
    procedure ConvertAM2PM;
    procedure ConvertPM2AM;
    procedure HourRange;
    procedure LCDNumber1DblClick(Sender: TObject);
    procedure ClearLCD;
    procedure HourExcept;
    procedure BitBtn3Click(Sender: TObject);
    procedure Basic1Click(Sender: TObject);
    procedure Advanced1Click(Sender: TObject);
    procedure Alarm1Click(Sender: TObject);
    procedure Counter1Click(Sender: TObject);
    procedure General1Click(Sender: TObject);
    procedure NoWarranty1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure RadioGroup1OnClick;
    procedure Help1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Close1Show(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure FindHelpBin;
    procedure COPYING1Click(Sender: TObject);
    procedure Information1Show(Sender: TObject);
    procedure Actions1Show(Sender: TObject);
    procedure Settings1Show(Sender: TObject);
    procedure BitBtn1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BitBtn2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ComboBoxesHints;
    procedure LCDNumber1MouseEnter(Sender: TObject);
    procedure AlarmExecute(Sender: TObject);
    procedure CounterExecute(Sender: TObject);
    procedure F5_PopUpMenuCallsExecute(Sender: TObject);
    procedure F2_ShowToDoListExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  end;

var
  Form1: TForm1;
  BaseTime, CurrentTime: String;
  Hour, Min: String[2];
  H, M: integer;

implementation

uses data, forks, optionsform, reminder;

{$R *.xfm}

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  if BitBtn2.Tag = 0 then Close
  else if BitBtn2.Tag = 1 Then begin
    if MessageDlg('Cancel ' + ComboBox1.Text + '?',
      mtConfirmation, [MbYes, MbNo], 0, MbNo) = mrYes then begin
        Form1.Timer1.Enabled := False;
        Form1.EnabBody;
      end;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if Form1.CheckBox1.Checked = False
    then begin
      Form1.Label1.Visible := True;
      Form1.Label2.Visible := False;
    end
    else begin
      Form1.Label1.Visible := False;
      Form1.Label2.Visible := True;
    end;

  HourExcept;
  HourRange;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  Form1.RadioGroup1OnClick;
end;

procedure TForm1.Label6MouseEnter(Sender: TObject);
begin
  Label6.Cursor := crHandPoint;
  Label6.Font.Color := clBlue;
  Label6.Font.Style := [fsUnderline];
end;

procedure TForm1.Label6MouseLeave(Sender: TObject);
begin
  Label6.Cursor := crDefault;
  Label6.Font.Color := clDefault;
  Label6.Font.Style := [];
end;

procedure TForm1.Label6Click(Sender: TObject);
begin
  Forks.parg[0] := 'netscape';
  Forks.parg[1] := 'http://cloxten.sourceforge.net';
  Forks.parg[2] := nil;

  TForks.Create.Execute;
end;

procedure TForm1.ComboBoxesChange;
begin
  Hour := IntToStr(ComboBox2.ItemIndex) + IntToStr(ComboBox3.ItemIndex);
  Min := IntToStr(ComboBox4.ItemIndex) + IntToStr(ComboBox5.ItemIndex);
  LCDNumber1.Value := Hour + ':' + Min;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  ComboBox2.MaxItems := -1;
  ComboBox3.MaxItems := -1;
  ComboBox2.Items := ComboBox5.Items;
  ComboBox3.Items := ComboBox5.Items;

  if ComboBox1.ItemIndex = 0 then begin
    HourRange;
    HourExcept; // Prevents Hour = 00 while PM activated.
  end;
  
  ComboBoxesChange;
end;

procedure TForm1.ComboBox3Change(Sender: TObject);
begin
  ComboBox2.MaxItems := -1;
  ComboBox3.MaxItems := -1;
  ComboBox2.Items := ComboBox5.Items;
  ComboBox3.Items := ComboBox5.Items;

  if ComboBox1.ItemIndex = 0 then begin
    HourRange;
    HourExcept;// Prevents Hour = 00 while PM activated.
  end;
  ComboBoxesChange;
end;

procedure TForm1.ComboBox4Change(Sender: TObject);
begin
  Form1.ComboBoxesChange;
end;

procedure TForm1.ComboBox5Change(Sender: TObject);
begin
  Form1.ComboBoxesChange;
end;

procedure TForm1.CountDown;
begin
  if H = 0 then begin
    if M > 0 then M := M - 1;
    if M = 0 then begin
      Form1.Timer1.Enabled := False;
      Form1.EnabBody;

      TForks.Create.Actions;
    end;
  end

  else if H > 0 then begin
    if M = 0 then begin
      H := H - 1;
      M := 60;
    end;
    if M > 0 then M := M - 1;
  end;

  DisplayAll;

  if (H > 0) or (M > 0)
    then Form1.Timer1.Enabled := True
    else Form1.Caption := 'Cloxten';
end;

procedure TForm1.ProgressiveCount;
begin
  if H = StrToInt(ComboBox2.Text + ComboBox3.Text) then begin
    if M < StrToInt(ComboBox4.Text + ComboBox5.Text) then M := M + 1;
    if M = StrToInt(ComboBox4.Text + ComboBox5.Text) then begin
      Form1.Timer1.Enabled := False;
      Form1.EnabBody;

      TForks.Create.Actions;
    end;
  end

  else if H < StrToInt(ComboBox2.Text + ComboBox3.Text) then begin
    if M < 60 then M := M + 1;
    if M = 60 then begin
      H := H + 1;
      M := 0;
    end;
  end;

  DisplayAll;

  if (H < StrToInt(ComboBox2.Text + ComboBox3.Text))
  or (M < StrToInt(ComboBox4.Text + ComboBox5.Text))
    then Form1.Timer1.Enabled := True
    else Form1.Caption := 'Cloxten';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if ComboBox1.ItemIndex = 0 then begin
    if RadioGroup1.ItemIndex = 0 then Timer12hs
    else if RadioGroup1.ItemIndex = 1 then Timer24hs;
  end

  else if ComboBox1.ItemIndex = 1 then begin
    if RadioGroup2.ItemIndex = 0 then Form1.CountDown
    else if RadioGroup2.ItemIndex = 1 then Form1.ProgressiveCount;
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if BitBtn1.Tag = 0
    then begin
      if ComboBox1.ItemIndex = 0
        then Start
        else begin
          if (ComboBox2.Text + ComboBox3.Text + ComboBox4.Text + ComboBox5.Text) = '0000'
            then ShowMessage('Alread set to 00:00')
            else begin
              BitBtn1.Tag := 1; // Tag's needed for Counter, but not for Timer.
              Start;
            end;
        end;
    end
    else begin
      if BitBtn1.Tag  = 1
        then begin
          BitBtn1.Tag := 2;
          Caption := 'Cloxten (Paused)';
          Pause;
        end
        else begin
          BitBtn1.Tag := 1;
          Caption := 'Cloxten (Restarted)';
          Restart;
        end;
    end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  ComboBox1OnChange;
end;

procedure TForm1.ComboBox1OnChange;
begin
  ClearLCD; { Reset Values to prevent out of range. }

  if Form1.ComboBox1.ItemIndex = 0 then begin
    if RadioGroup1.ItemIndex = 0 then begin
      ComboBox2.MaxItems := 2;
      ComboBox2.Items := ComboBox5.Items;
      if RadioGroup1.Tag = 0 then Form1.CheckBox1.Enabled := True
      { To prevent 'Enabled=True' on internal AM/PM convertions. }

      else if CheckBox1.Checked = False
        then begin
          ComboBox3.MaxItems := 2;
          ComboBox3.Items := ComboBox5.Items;
          Label1.Visible := True;//
        end
        else begin
          ComboBox3.MaxItems := 3;
          ComboBox3.Items := ComboBox5.Items;
          Label2.Visible := True;//
        end;
    end
    else begin
      ComboBox2.MaxItems := 3;
      ComboBox3.MaxItems := 4;
      ComboBox2.Items := ComboBox5.Items;
      ComboBox3.Items := ComboBox5.Items;
    end;

    Label3.Caption := 'Hours';
    Label4.Caption := 'Minutes';

    RadioGroup1.BringToFront;
    RadioGroup1.Enabled := True;
    RadioGroup2.Enabled := False;

    CheckBox1.Visible := True;
    CheckBox2.Visible := False;

    HourExcept;
    HourRange;
  end

  else begin
    ComboBox2.MaxItems := -1;
    ComboBox3.MaxItems := -1;
    ComboBox2.Items := ComboBox5.Items;
    ComboBox3.Items := ComboBox5.Items;

    Label3.Caption := 'Minutes';
    Label4.Caption := 'Seconds';

    RadioGroup1.Enabled := False;
    RadioGroup2.BringToFront;
    RadioGroup2.Enabled := True;

    CheckBox1.Visible := False;
    CheckBox2.Visible := True;

    Label1.Visible := False;
    Label2.Visible := False;
    CheckBox1.Enabled := False;
  end;
end;

procedure TForm1.DisabBody;
begin
  if Form2.CheckBox9.Checked = True then begin
    Form3.ShowEventsAndTasks;
    Form3.Tag := 1;
    Form3.Show;
  end;

  if ComboBox1.ItemIndex = 0
    then BitBtn1.Enabled := False
    else BitBtn1.Caption := '&Pause';

  BitBtn2.Tag := 1;
  BitBtn2.Caption := '&Cancel';

  RadioGroup1.Enabled := False; //Even if not visible.
  RadioGroup2.Enabled := False; //Idem.
  CheckBox1.Enabled := False; //Idem.
  CheckBox2.Enabled := False; //Idem.
  ComboBox1.Enabled := False;
  ComboBox2.Enabled := False;
  ComboBox3.Enabled := False;
  ComboBox4.Enabled := False;
  ComboBox5.Enabled := False;

  Form1.Tag := 1; { Status = Disabled }

  { Prevents Form1 to force Form3 to minimize too. }
  if (Form2.CheckBox8.Checked = True)
  and (Form2.CheckBox9.Checked = False)
    then Form1.WindowState := wsMinimized;
end;

procedure TForm1.EnabBody;
begin
  if ComboBox1.ItemIndex = 0
    then BitBtn1.Enabled := True
    else BitBtn1.Tag := 0;
    
  BitBtn1.Caption := '&Start';
  BitBtn2.Tag := 0;
  BitBtn2.Caption := '&Close';

  RadioGroup1.Enabled := True; //Even if not visible.
  RadioGroup2.Enabled := True; //Idem.
  if RadioGroup1.ItemIndex = 0
    then CheckBox1.Enabled := True; //Idem.
  CheckBox2.Enabled := True; //Idem.
  ComboBox1.Enabled := True;
  ComboBox2.Enabled := True;
  ComboBox3.Enabled := True;
  ComboBox4.Enabled := True;
  ComboBox5.Enabled := True;

  ComboBoxesChange;

  Form1.Tag := 0; { Status = Enabled }
  Form1.Caption := 'Cloxten';
end;

procedure TForm1.DisplayAll;
begin
  Hour := SysUtils.IntToStr(H);
  if M < 10 then Min := '0' + SysUtils.IntToStr(M)
    else Min := SysUtils.IntToStr(M);

  if H < 10 then Hour := '0' + SysUtils.IntToStr(H)
    else Hour := SysUtils.IntToStr(H);

  LCDNumber1.Value := Hour + ':' + Min;
  Form1.Caption := LCDNumber1.Value + ' - Cloxten';
end;

procedure TForm1.Start;
begin
  if Form1.ComboBox1.ItemIndex = 0 then begin
    // This will convert time to PM if in AM mode.
    // Only to get BaseTime in PM. It will be reset after that.
    if RadioGroup1.ItemIndex = 0 then begin
      RadioGroup1.ItemIndex := 1;
      RadioGroup1.Tag := 1;
      RadioGroup1OnClick;
    end;

    Hour := ComboBox2.Text + ComboBox3.Text;
    Min := ComboBox4.Text + ComboBox5.Text;

    BaseTime := Hour + ':' + Min + ':00';

    // This will revert time to AM mode. Only if it starts in this mode.
    if RadioGroup1.Tag = 1 then begin
      RadioGroup1.ItemIndex := 0;
      RadioGroup1.Tag := 0;
      RadioGroup1OnClick;
    end;

    Form1.DisabBody;

    Form1.Caption := SysUtils.TimeToStr(SysUtils.Time) + ' - Cloxten';
  end


  else if Form1.ComboBox1.ItemIndex = 1 then begin
    Form1.DisabBody;

    if Form1.RadioGroup2.ItemIndex = 0 then begin
      Hour := ComboBox2.Text + ComboBox3.Text;
      Min := ComboBox4.Text + ComboBox5.Text;

      H := StrToInt(Hour); M := StrToInt(Min);
    end;

    if Form1.RadioGroup2.ItemIndex = 1 then begin
      H := 0; M := 0;
      Hour := '00'; Min := '00';
    end;

    LCDNumber1.Value := Hour + ':' + Min;
    Form1.Caption := LCDNumber1.Value + ' - Cloxten';
  end;

  if Form2.CheckBox9.Checked = False
    then Form1.Timer1.Enabled := True;
end;

procedure TForm1.Pause;
begin
  Form1.Timer1.Enabled := False;
  BitBtn1.Caption := '&Restart';
end;

procedure TForm1.Restart;
begin
  Form1.Timer1.Enabled := True;
  BitBtn1.Caption := '&Pause';
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  FindHelpBin;

  if Forks.parg[0] <> nil then begin
    Forks.parg[1] := PChar('-m');
    Forks.parg[2] := PChar('-ns');
    Forks.parg[3] := nil;
    TForks.Create.Execute;
  end;
end;

procedure TForm1.Timer12hs;
begin
  Timer24hs;// --------------------------> To do the same as mode 24hs.
end;

procedure TForm1.Timer24hs;
begin
  if BaseTime <> SysUtils.TimeToStr(SysUtils.Time)
    then begin
      Form1.Caption := SysUtils.TimeToStr(SysUtils.Time) + ' - Cloxten';
      Form1.Timer1.Enabled := True;
    end
    else begin
      Form1.Timer1.Enabled := False;
      Form1.EnabBody;

      TForks.Create.Actions;
      Form1.Caption := 'Cloxten';
    end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked = True then begin
    Label3.Caption := 'Minutes';
    Label4.Caption := 'Seconds';
    Timer1.Interval := 1000;
  end
  else begin
    Label3.Caption := 'Hours';
    Label4.Caption := 'Minutes';
    Timer1.Interval := 60000;
  end;

  ComboBoxesHints;
end;

procedure TForm1.ConvertAM2PM;
begin
  if CheckBox1.Checked = True then begin
    if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 1)
    then begin
      ComboBox2.ItemIndex := 1;
      ComboBox3.ItemIndex := 3;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 2)
    then begin
      ComboBox2.ItemIndex := 1;
      ComboBox3.ItemIndex := 4;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 3)
    then begin
      ComboBox2.ItemIndex := 1;
      ComboBox3.ItemIndex := 5;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 4)
    then begin
      ComboBox2.ItemIndex := 1;
      ComboBox3.ItemIndex := 6;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 5)
    then begin
      ComboBox2.ItemIndex := 1;
      ComboBox3.ItemIndex := 7;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 6)
    then begin
      ComboBox2.ItemIndex := 1;
      ComboBox3.ItemIndex := 8;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 7)
    then begin
      ComboBox2.ItemIndex := 1;
      ComboBox3.ItemIndex := 9;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 8)
    then begin
      ComboBox2.ItemIndex := 2;
      ComboBox3.ItemIndex := 0;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 9)
    then begin
      ComboBox2.ItemIndex := 2;
      ComboBox3.ItemIndex := 1;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 1) and (ComboBox3.ItemIndex = 0)
    then begin
      ComboBox2.ItemIndex := 2;
      ComboBox3.ItemIndex := 2;
      CheckBox1.Checked := False;
    end

    else if (ComboBox2.ItemIndex = 1) and (ComboBox3.ItemIndex = 1)
    then begin
      ComboBox2.ItemIndex := 2;
      ComboBox3.ItemIndex := 3;
      CheckBox1.Checked := False;
    end;
  end;
end;

procedure TForm1.ConvertPM2AM;
begin
  if ComboBox2.ItemIndex = 1 then begin
    if ComboBox3.ItemIndex = 2 then CheckBox1.Checked := True

    else if ComboBox3.ItemIndex = 3 then begin
      ComboBox2.ItemIndex := 0;
      ComboBox3.ItemIndex := 1;
      CheckBox1.Checked := True;
    end

    else if ComboBox3.ItemIndex = 4 then begin
      ComboBox2.ItemIndex := 0;
      ComboBox3.ItemIndex := 2;
      CheckBox1.Checked := True;
    end

    else if ComboBox3.ItemIndex = 5 then begin
      ComboBox2.ItemIndex := 0;
      ComboBox3.ItemIndex := 3;
      CheckBox1.Checked := True;
    end

    else if ComboBox3.ItemIndex = 6 then begin
      ComboBox2.ItemIndex := 0;
      ComboBox3.ItemIndex := 4;
      CheckBox1.Checked := True;
    end

    else if ComboBox3.ItemIndex = 7 then begin
      ComboBox2.ItemIndex := 0;
      ComboBox3.ItemIndex := 5;
      CheckBox1.Checked := True;
    end

    else if ComboBox3.ItemIndex = 8 then begin
      ComboBox2.ItemIndex := 0;
      ComboBox3.ItemIndex := 6;
      CheckBox1.Checked := True;
    end

    else if ComboBox3.ItemIndex = 9 then begin
      ComboBox2.ItemIndex := 0;
      ComboBox3.ItemIndex := 7;
      CheckBox1.Checked := True;
    end
  end;

  if ComboBox2.ItemIndex = 2 then begin
    if ComboBox3.ItemIndex = 0 then begin
      ComboBox2.ItemIndex := 0;
      ComboBox3.ItemIndex := 8;
      CheckBox1.Checked := True;
    end

    else if ComboBox3.ItemIndex = 1 then begin
      ComboBox2.ItemIndex := 0;
      ComboBox3.ItemIndex := 9;
      CheckBox1.Checked := True;
    end

    else if ComboBox3.ItemIndex = 2 then begin
      ComboBox2.ItemIndex := 1;
      ComboBox3.ItemIndex := 0;
      CheckBox1.Checked := True;
    end

    else if ComboBox3.ItemIndex = 3 then begin
      ComboBox2.ItemIndex := 1;
      ComboBox3.ItemIndex := 1;
      CheckBox1.Checked := True;
    end;
  end;
end;

procedure TForm1.HourRange;
begin
  if RadioGroup1.ItemIndex = 0 then begin
    if ComboBox2.ItemIndex = 0
      then begin
        ComboBox3.MaxItems := -1;
        ComboBox3.Items := ComboBox5.Items;
      end
    else if ComboBox2.ItemIndex = 1 then begin
      if CheckBox1.Checked = True
        then begin
          ComboBox3.MaxItems := 3;
          ComboBox3.Items := ComboBox5.Items;
        end
        else begin
          ComboBox3.MaxItems := 2;
          ComboBox3.Items := ComboBox5.Items;
        end;
    end;

    if ComboBox3.ItemIndex < 3
      then begin
        ComboBox2.MaxItems := 2;
        ComboBox2.Items := ComboBox5.Items;
      end
    else if ComboBox3.ItemIndex > 2
      then begin
        ComboBox2.MaxItems := 1;
        ComboBox2.Items := ComboBox5.Items;
      end;
  end

  else if RadioGroup1.ItemIndex = 1 then begin
    if ComboBox2.ItemIndex = 0
      then begin
        ComboBox3.MaxItems := -1;
        ComboBox3.Items := ComboBox5.Items;
      end
    else if ComboBox2.ItemIndex = 1
      then begin
        ComboBox3.MaxItems := -1;
        ComboBox3.Items := ComboBox5.Items;
      end
    else if ComboBox2.ItemIndex = 2
      then begin
        ComboBox3.MaxItems := 4;
        ComboBox3.Items := ComboBox5.Items;
      end;

    if ComboBox3.ItemIndex < 4
      then begin
        ComboBox2.MaxItems := 3;
        ComboBox2.Items := ComboBox5.Items;
      end
    else if ComboBox3.ItemIndex > 3
      then begin
        ComboBox2.MaxItems := 2;
        ComboBox2.Items := ComboBox5.Items;
      end;
  end;
end;

procedure TForm1.LCDNumber1DblClick(Sender: TObject);
begin
  { If body enabled; clear LCD; If body disabled, call cancel query. }
  if Form1.Tag = 0 then ClearLCD
  else if Form1.Tag = 1 then BitBtn2.Click; { Do not clear LCD. }
end;

procedure TForm1.ClearLCD;
begin
{ Reset Values. }
  ComboBox2.ItemIndex := 0;
  ComboBox3.ItemIndex := 0;
  ComboBox4.ItemIndex := 0;
  ComboBox5.ItemIndex := 0;
  CheckBox1.Checked := False;

  if ComboBox1.ItemIndex = 0
    then HourRange;// ------------------------> Prevent "Out of range".

  ComboBoxesChange;// ------------------> Make all necessaries changes.
end;

procedure TForm1.HourExcept;
begin
  if RadioGroup1.ItemIndex = 0 then begin { Only for 12hs. }
    if CheckBox1.Checked = True then begin
      if (ComboBox2.ItemIndex = 0) and (ComboBox3.ItemIndex = 0) then begin
        ComboBox2.ItemIndex := 1; ComboBox3.ItemIndex := 2;
        ComboBoxesChange;
      end;
    end
    else begin { CheckBox1.Checked = False }
      if (ComboBox2.ItemIndex = 1) and (ComboBox3.ItemIndex = 2) then begin
        ComboBox2.ItemIndex := 0; ComboBox3.ItemIndex := 0;
        ComboBoxesChange;
      end;
    end;
  end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  PopupMenu1.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TForm1.Basic1Click(Sender: TObject);
begin
  Form2.NoInfo;
  Form2.PageControl2.Pages[0].Show;
  Form2.ShowModal;
end;

procedure TForm1.Advanced1Click(Sender: TObject);
begin
  Form2.NoInfo;
  Form2.PageControl2.Pages[1].Show;
  Form2.ShowModal;
end;

procedure TForm1.Alarm1Click(Sender: TObject);
begin
  Form2.NoInfo;
  Form2.PageControl3.Pages[0].Show;
  Form2.ShowModal;
end;

procedure TForm1.Counter1Click(Sender: TObject);
begin
  Form2.NoInfo;
  Form2.PageControl3.Pages[1].Show;
  Form2.ShowModal;
end;

procedure TForm1.General1Click(Sender: TObject);
begin
  Form2.NoInfo;
  Form2.PageControl3.Pages[2].Show;
  Form2.ShowModal;
end;

procedure TForm1.NoWarranty1Click(Sender: TObject);
begin
  Form2.NoControls;
  Form2.PageControl1.Pages[3].Show;
  Form2.ShowModal;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  Form2.NoControls;
  Form2.PageControl1.Pages[4].Show;
  Form2.ShowModal;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if Form1.Tag = 0 then begin
    if Form2.CheckBox6.Checked = True then begin
      if MessageDlg('Are you sure you want to quit?',
        mtConfirmation, [MbYes, MbNo], 0, MbNo) = mrNo
        then CanClose := False;
    end;
  end

  else if Form1.Tag = 1 then begin
    if MessageDlg(ComboBox1.Text + ' running. Quit anyway?',
      mtConfirmation, [MbYes, MbNo], 0, MbNo) = mrNo
      then CanClose := False;
  end;
end;

procedure TForm1.RadioGroup1OnClick;
begin
  ComboBox2.MaxItems := -1;
  ComboBox3.MaxItems := -1;
  ComboBox2.Items := ComboBox5.Items;
  ComboBox3.Items := ComboBox5.Items;

  if Form1.RadioGroup1.ItemIndex = 0
    then begin
      ConvertPM2AM;

      if RadioGroup1.Tag = 0 then Form1.CheckBox1.Enabled := True;
      { To prevent 'Enabled=True' on internal AM/PM convertions. }

      if Form1.CheckBox1.Checked = False
        then begin
          Form1.Label1.Visible := True;
          Form1.Label2.Visible := False;
        end
        else begin
          Form1.Label1.Visible := False;
          Form1.Label2.Visible := True;
        end;
    end

  else if Form1.RadioGroup1.ItemIndex = 1
    then begin
      ConvertAM2PM;

      Form1.CheckBox1.Enabled := False;

      Form1.Label1.Visible := False;
      Form1.Label2.Visible := False;
    end;

  ComboBoxesChange;
  HourRange; // After all, corrects the range of ComboBoxes 2 & 3.
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
  BitBtn4.Click;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  BitBtn2.Click;
end;

procedure TForm1.Close1Show(Sender: TObject);
begin
  if Form1.Tag = 0
    then Close1.Caption := '&Close'
    else Close1.Caption := '&Cancel';
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
  if Form2.CheckBox7.Checked = True
    then PopupMenu1.AutoPopup := True
    else PopupMenu1.AutoPopup := False;
end;

procedure TForm1.FindHelpBin;
begin
  if SysUtils.FileExists('/usr/bin/doctordoc')
    then Forks.parg[0] := PChar('/usr/bin/doctordoc')
  else if SysUtils.FileExists('/usr/local/bin/doctordoc')
    then Forks.parg[0] := PChar('/usr/local/bin/doctordoc')
  else if SysUtils.FileExists(SysUtils.GetCurrentDir + '/doctordoc')
    then Forks.parg[0] := PChar(SysUtils.GetCurrentDir + '/doctordoc')
  else ShowMessage(
    'DoctorDoc not found! Please, check your installation or take a look at ' +
    'http://cloxten.sf.net');
end;

procedure TForm1.COPYING1Click(Sender: TObject);
begin
  Form2.NoControls;
  Form2.PageControl1.Pages[2].Show;
  Form2.ShowModal;
end;

procedure TForm1.Information1Show(Sender: TObject);
begin
  if Tag = 0 then begin
    COPYING1.Enabled := True;
    NoWarranty1.Enabled := True;
    About1.Enabled := True;
  end
  else begin
    COPYING1.Enabled := False;
    NoWarranty1.Enabled := False;
    About1.Enabled := False;
  end;
end;

procedure TForm1.Actions1Show(Sender: TObject);
begin
  if Tag = 0 then begin
    Basic1.Enabled := True;
    Advanced1.Enabled := True;
  end
  else begin
    Basic1.Enabled := False;
    Advanced1.Enabled := False;
  end;
end;

procedure TForm1.Settings1Show(Sender: TObject);
begin
  if Tag = 0 then begin
    Alarm1.Enabled := True;
    Counter1.Enabled := True;
    General1.Enabled := True;
  end
  else begin
    Alarm1.Enabled := False;
    Counter1.Enabled := False;
    General1.Enabled := False;
  end;
end;

procedure TForm1.BitBtn1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if BitBtn1.Caption = '&Start'
    then BitBtn1.Hint := '|Start ' + ComboBox1.Text
  else if BitBtn1.Caption = '&Pause'
    then BitBtn1.Hint := '|Pause ' + ComboBox1.Text
  else if BitBtn1.Caption = '&Restart'
    then BitBtn1.Hint := '|Restart ' + ComboBox1.Text;
end;

procedure TForm1.BitBtn2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Tag = 0
    then BitBtn2.Hint := '|Close the application.'
    else BitBtn2.Hint := '|Cancel ' + ComboBox1.Text;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBoxesHints;
end;

procedure TForm1.ComboBoxesHints;
begin
  if CheckBox2.Checked = True then begin
    ComboBox2.Hint := '|Minutes: The first digit.';
    ComboBox3.Hint := '|Minutes: The second digit.';
    ComboBox4.Hint := '|Seconds: The first digit.';
    ComboBox5.Hint := '|Seconds: The second digit.';
  end
  else begin
    ComboBox2.Hint := '|Hours: The first digit.';
    ComboBox3.Hint := '|Hours: The second digit.';
    ComboBox4.Hint := '|Minutes: The first digit.';
    ComboBox5.Hint := '|Minutes: The second digit.';
  end;
end;

procedure TForm1.LCDNumber1MouseEnter(Sender: TObject);
begin
  if Tag = 0
    then LCDNumber1.Hint := '|Liquid Cristal Display. - Double click to reset.'
    else LCDNumber1.Hint := '|Liquid Cristal Display. - Double click to cancel.';
end;

procedure TForm1.AlarmExecute(Sender: TObject);
begin
  if Form1.Tag = 0 then begin
    ComboBox1.ItemIndex := 0;
    ComboBox1OnChange;
  end;
end;

procedure TForm1.CounterExecute(Sender: TObject);
begin
  if Form1.Tag = 0 then begin
    ComboBox1.ItemIndex := 1;
    ComboBox1OnChange;
  end;
end;

procedure TForm1.F5_PopUpMenuCallsExecute(Sender: TObject);
begin
  TData.Create.CheckFiles;
  if CONFIG_EXISTS = True then begin
    if Form2.CheckBox7.Checked = True then begin
      Form2.CheckBox7.Checked := False;
      Form1.StatusBar1.Panels[0].Text := 'Popup Menu disabled.';
      Form1.StatusBar1.Panels[1].Text := EmptyWideStr;
    end
    else begin
      Form2.CheckBox7.Checked := True;
      Form1.StatusBar1.Panels[0].Text := 'Popup Menu enabled.';
      Form1.StatusBar1.Panels[1].Text := 'PopUp';
    end;
    TData.Create.RecData;
  end;
end;

procedure TForm1.F2_ShowToDoListExecute(Sender: TObject);
begin
  reminder.ShowingNotes := True;
  Form3.ShowEventsAndTasks;
  Form3.ShowModal;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Form2.CheckBox7.Checked = true
    then Form1.StatusBar1.Panels[1].Text := 'PopUp'
    else Form1.StatusBar1.Panels[1].Text := EmptyWideStr;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Form2.RadioButton4.Checked = False then begin
    DeleteFile(Data.HOME_DIR + '/.cloxten/mail.txt');
    DeleteFile(Data.HOME_DIR + '/.cloxten/mail.tmp');
  end;
end;

end.

