{***************************************************************************
                  optionsform.pas   -  Control window form.
                             -------------------
    copyright            : (C) 2002 Alberto Lohmann
    email                : lohmann@users.sourceforge.net
    app. url             : http://cloxten.sourceforge.net
    project url          : http://sourceforge.net/projects/cloxten
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************}

// * This file is part of Cloxten program.



unit optionsform;

interface

uses
  {$IFDEF LINUX} Libc {$ENDIF},
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, QComCtrls, QButtons, QActnList, QStdActns;

type
  TForm2 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    PageControl2: TPageControl;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button1: TButton;
    Button2: TButton;
    RadioGroup2: TRadioGroup;
    RadioButton3: TRadioButton;
    RadioButton5: TRadioButton;
    Button3: TButton;
    Button4: TButton;
    TabSheet2: TTabSheet;
    PageControl3: TPageControl;
    TabSheet5: TTabSheet;
    RadioGroup3: TRadioGroup;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    CheckBox3: TCheckBox;
    TabSheet6: TTabSheet;
    RadioGroup4: TRadioGroup;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    CheckBox4: TCheckBox;
    TabSheet7: TTabSheet;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    TabSheet8: TTabSheet;
    Memo1: TMemo;
    TabSheet9: TTabSheet;
    Memo2: TMemo;
    TabSheet10: TTabSheet;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    RadioGroup5: TRadioGroup;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    TabSheet11: TTabSheet;
    Memo3: TMemo;
    RadioButton4: TRadioButton;
    ActionList1: TActionList;
    HelpContents: THelpContents;
    procedure ButtonsReord;
    procedure ButtonsNormal;
    procedure TabSheet2Show(Sender: TObject);
    procedure TabSheet1Show(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure OpenDialog1FileAdd(Sender: TObject; const Filename: String;
      const Readable, Writeable, Executable: Boolean; var CanAdd: Boolean);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure RadioButton8Click(Sender: TObject);
    procedure RadioButton9Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure RadioButton10Click(Sender: TObject);
    procedure RadioButton11Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure NoControls;
    procedure NoInfo;
    procedure TabSheet11Show(Sender: TObject);
    procedure TabSheet10Show(Sender: TObject);
    procedure TabSheet9Show(Sender: TObject);
    procedure TabSheet8Show(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ClearMailCache;
    procedure TaskStatus;
    procedure TabSheet4Show(Sender: TObject);
    procedure OK;
    procedure NotOKMsgs;
    procedure PageControl2Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure PageControl1PageChanging(Sender: TObject; NewPage: TTabSheet;
      var AllowChange: Boolean);
    procedure GetTempMailStrs;
    Procedure SetTempMailStrs;
    procedure HelpContentsExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
  end;

var
  Form2: TForm2;
  FileToRun, FileToPlay, MsgArgsStr, TempStr: String;

implementation

uses mainform, data, forks, mail;

{$R *.xfm}

procedure TForm2.ButtonsReord;
begin
  BitBtn1.Enabled := False;
  BitBtn1.Visible := False;
  BitBtn2.Enabled := False;
  BitBtn2.Visible := False;
  BitBtn3.Enabled := False;
  BitBtn3.Visible := False;
end;

procedure TForm2.ButtonsNormal;
begin
  BitBtn1.Enabled := True;
  BitBtn1.Visible := True;
  BitBtn2.Enabled := True;
  BitBtn2.Visible := True;
  BitBtn3.Enabled := True;
  BitBtn3.Visible := True;
end;

procedure TForm2.TabSheet2Show(Sender: TObject);
begin
  ButtonsNormal;
end;

procedure TForm2.TabSheet1Show(Sender: TObject);
begin
  ButtonsNormal;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  Beep;
end;

procedure TForm2.RadioButton1Click(Sender: TObject);
begin
  if RadioButton1.Checked = True then begin
    Button1.Enabled := True;
    Button2.Enabled := False;
  end;
end;

procedure TForm2.RadioButton2Click(Sender: TObject);
begin
  if RadioButton2.Checked = True then begin
    Button1.Enabled := False;
    Button2.Enabled := True;
  end;
end;

procedure TForm2.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked = True then begin
    RadioButton1.Enabled := True;
    if RadioButton1.Checked = True then Button1.Enabled := True;
  end
  else begin
    RadioButton1.Enabled := False;
    RadioButton2.Enabled := False;
    Button1.Enabled := False;
    Button2.Enabled := False;
  end;
end;

procedure TForm2.RadioButton4Click(Sender: TObject);
begin
  TaskStatus;
end;

procedure TForm2.RadioButton5Click(Sender: TObject);
begin
  TaskStatus;
end;

procedure TForm2.RadioButton3Click(Sender: TObject);
begin
  TaskStatus;
end;

procedure TForm2.RadioButton6Click(Sender: TObject);
begin
  if RadioButton6.Checked = True then CheckBox3.Enabled := True;
  Form1.RadioGroup1.ItemIndex := 0;
  if CheckBox3.Checked = True
    then Form1.CheckBox1.Checked := True
    else Form1.CheckBox1.Checked := False;
end;

procedure TForm2.RadioButton7Click(Sender: TObject);
begin
  if RadioButton7.Checked = True then CheckBox3.Enabled := False;
  Form1.RadioGroup1.ItemIndex := 1;
end;

procedure TForm2.Button4Click(Sender: TObject);
begin
  TempStr := FileToRun;
  OpenDialog1.FileName := FileToRun;   { If not empty. }
  if OpenDialog1.Execute then
    FileToRun := OpenDialog1.FileName; { Get FileName. }
  TaskStatus;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  OpenDialog1.Execute;
  FileToPlay:= OpenDialog1.FileName;
end;

procedure TForm2.OpenDialog1FileAdd(Sender: TObject;
  const Filename: String; const Readable, Writeable, Executable: Boolean;
  var CanAdd: Boolean);
begin
  if Executable = False
    then CanAdd := False
    else CanAdd := True;
end;

procedure TForm2.BitBtn1Click(Sender: TObject);
begin
  if Label1.Font.Color = clRed
    then NotOKMsgs
    else begin
      if RadioButton4.Checked = False
        then begin
          if FileExists(Data.HOME_DIR + '/.cloxten/mail.tmp') then begin
            SysUtils.RenameFile(Data.HOME_DIR + '/.cloxten/mail.tmp',
                                Data.HOME_DIR + '/.cloxten/mail.txt');
          end;

          ////////////////////////

          //SysUtils.DeleteFile(Data.HOME_DIR + '/.cloxten/mail.txt'); // //
          //SysUtils.DeleteFile(Data.HOME_DIR + '/.cloxten/mail.tmp');
          ClearMailCache;
        end
        else begin
          Form2.SetTempMailStrs;//
          if FileExists(Data.HOME_DIR + '/.cloxten/mail.tmp')
            then DeleteFile(Data.HOME_DIR + '/.cloxten/mail.tmp'); //
         // SysUtils.RenameFile(Data.HOME_DIR + '/.cloxten/mail.tmp',
         //                     Data.HOME_DIR + '/.cloxten/mail.txt');
         // SysUtils.DeleteFile(Data.HOME_DIR + '/.cloxten/mail.tmp');  //tmp=txt/
        end;
      OK;
    end;
end;

procedure TForm2.BitBtn2Click(Sender: TObject);
begin
  if (RadioButton4.Checked = True) and
     (FileExists(Data.HOME_DIR + '/.cloxten/mail.tmp') = True) then begin
        SysUtils.DeleteFile(Data.HOME_DIR + '/.cloxten/mail.txt');
        SysUtils.RenameFile(Data.HOME_DIR + '/.cloxten/mail.tmp',
                            Data.HOME_DIR + '/.cloxten/mail.txt');
  end;

  TData.Create.CheckFiles;
  if CONFIG_EXISTS = True
    then TData.Create.RetrieveData;
end;

procedure TForm2.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked = True
    then Form1.CheckBox1.Checked := True
    else Form1.CheckBox1.Checked := False;
end;

procedure TForm2.RadioButton8Click(Sender: TObject);
begin
  if RadioButton8.Checked = True then Form1.RadioGroup2.ItemIndex := 0;
end;

procedure TForm2.RadioButton9Click(Sender: TObject);
begin
  if RadioButton9.Checked = True then Form1.RadioGroup2.ItemIndex := 1;
end;

procedure TForm2.CheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked = True then Form1.CheckBox2.Checked := True
    else Form1.CheckBox2.Checked := False;
end;

procedure TForm2.RadioButton10Click(Sender: TObject);
begin
  if RadioButton10.Checked = True then begin
    Form1.ComboBox1.ItemIndex := 0;
    Form1.ComboBox1OnChange;
  end;
end;

procedure TForm2.RadioButton11Click(Sender: TObject);
begin
  if RadioButton11.Checked = True then begin
    Form1.ComboBox1.ItemIndex := 1;
    Form1.ComboBox1OnChange;
  end;
end;

procedure TForm2.CheckBox7Click(Sender: TObject);
begin
  if Form2.CheckBox7.Checked = True then begin
    Form1.PopupMenu1.AutoPopup := True;
    Form1.Hint := '|Right click for Popup Menu';
  end
  else begin
    Form1.PopupMenu1.AutoPopup := False;
    Form1.Hint := '|Popup Menu disabled. F5 to enable.';
  end;
end;

procedure TForm2.BitBtn3Click(Sender: TObject);
begin
  Form1.FindHelpBin;

  if Forks.parg[0] <> nil then begin
    if TabSheet3.CanFocus = True then Forks.parg[1] := PChar('-b')
    else if TabSheet4.CanFocus = True then Forks.parg[1] := PChar('-d')
    else if TabSheet5.CanFocus = True then Forks.parg[1] := PChar('-a')
    else if TabSheet6.CanFocus = True then Forks.parg[1] := PChar('-c')
    else if TabSheet7.CanFocus = True then Forks.parg[1] := PChar('-g');
    Forks.parg[2] := PChar('-ns');
    Forks.parg[3] := nil;
    TForks.Create.Execute;
  end;
end;

procedure TForm2.NoControls;
begin
  Caption := 'Cloxten''s Information';
  PageControl1.Pages[0].TabVisible := False;
  PageControl1.Pages[1].TabVisible := False;
  PageControl1.Pages[2].TabVisible := True;
  PageControl1.Pages[3].TabVisible := True;
  PageControl1.Pages[4].TabVisible := True;
end;

procedure TForm2.NoInfo;
begin
  Caption := 'Cloxten''s Control Window';
  PageControl1.Pages[0].TabVisible := True;
  PageControl1.Pages[1].TabVisible := True;
  PageControl1.Pages[2].TabVisible := False;
  PageControl1.Pages[3].TabVisible := False;
  PageControl1.Pages[4].TabVisible := False;
end;

procedure TForm2.TabSheet11Show(Sender: TObject);
begin
  BitBtn2.Click; // Same as Cancel Pressed.
end;

procedure TForm2.TabSheet10Show(Sender: TObject);
begin
  ButtonsReord;
end;

procedure TForm2.TabSheet9Show(Sender: TObject);
begin
  ButtonsReord;
end;

procedure TForm2.TabSheet8Show(Sender: TObject);
begin
  ButtonsReord;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  { if future form4 cancel pressed, define return status. }
  { 0 = Mail is OK; 1 = Mail is not OK. }
  if RadioButton4.Tag = 1
    then ClearMailCache
    else begin
      GetTempMailStrs;

    end; // // //

      if SysUtils.FileExists(Data.HOME_DIR + '/.cloxten/mail.txt') = True then begin
        if MessageDlg('A previous mail message is in cache. Do you want to use it?',
          mtConfirmation, [MbYes, MbNo], 0, MbNo) = mrYes
          then begin
            SetTempMailStrs;//
            if FileExists(Data.HOME_DIR + '/.cloxten/mail.txt')//
              then Form4.Memo1.Lines.LoadFromFile(Data.HOME_DIR + '/.cloxten/mail.txt');//
          end
          else ClearMailCache;
      end
      else begin
        SetTempMailStrs;//
        if FileExists(Data.HOME_DIR + '/.cloxten/mail.txt')//
           then Form4.Memo1.Lines.LoadFromFile(Data.HOME_DIR + '/.cloxten/mail.txt');//
      end;
    // // // end;//

  Form4.ShowModal;
  TaskStatus;
end;

procedure TForm2.ClearMailCache; { ram only, not disk yet }
begin
  MsgArgsStr := '';
  Form4.Edit2.Text := '';
  Form4.Edit3.Text := '';
  Form4.Edit4.Text := '';
  Form4.Edit5.Text := '';
  Form4.Memo1.Text := '';
end;

procedure TForm2.TaskStatus;
begin
  if RadioButton3.Checked = True then begin
    Button3.Enabled := False;
    Button4.Enabled := False;
    Label1.Font.Color := clDefault;
    Label1.Caption := 'No advanced tasks.';
  end
  else if RadioButton4.Checked = True then begin
    Button3.Enabled := True;
    Button4.Enabled := False;

//    if (Form4.Edit2.Text = '') and (Form4.Memo1.Text = '')
    if (Form4.ListBox1.Items[0] = '') and (Form4.Memo1.Text = '')
      then begin
        Label1.Font.Color := clRed;
        Label1.Caption := 'Message need to be writen or checked. Click on ' +
                          '"Write" button.';
        RadioButton4.Tag := 1; { Message is not OK. }
      end
      else begin
        Label1.Font.Color := clGreen;
        Label1.Caption := 'Message is OK.';
        RadioButton4.Tag := 0; { Message is OK. }
      end;
  end
  else if RadioButton5.Checked = True then begin
    Button3.Enabled := False;
    Button4.Enabled := True;

    if FileToRun = '' then begin
      Label1.Font.Color := clRed;
      Label1.Caption := 'No executable. Click on "Browse" button to choose one';
      RadioButton5.Tag := 1; { File name is empty. }
    end
    else begin
      Label1.Font.Color := clGreen;
      Label1.Caption := 'Current executable: ' +
                         basename(PChar(FileToRun));
      RadioButton5.Tag := 0; { File name OK. }
    end;
  end;

  if Label1.Font.Color = clRed
    then Bitbtn1.Enabled := False
    else Bitbtn1.Enabled := True;
end;

procedure TForm2.TabSheet4Show(Sender: TObject);
begin
  GetTempMailStrs;
  TaskStatus;
end;

procedure TForm2.OK;
begin
  TData.Create.CheckFiles;
  if CONFIG_EXISTS = True
    then TData.Create.RecData;
  Form2.Close;
end;

procedure TForm2.NotOKMsgs;
begin
  if RadioButton4.Checked = True
    then ShowMessage('Message isn''t OK. Click on "Write" button.')
  else if RadioButton5.Checked = True
    then ShowMessage('You must choose a executable. Click on "Browse" button.');
end;

procedure TForm2.PageControl2Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  if (PageControl2.Pages[1].Showing = True) and (Label1.Font.Color = clRed)
    then begin
      NotOKMsgs;
      AllowChange := False;
    end;
end;

procedure TForm2.PageControl1PageChanging(Sender: TObject;
  NewPage: TTabSheet; var AllowChange: Boolean);
begin
  if PageControl2.Pages[1].Showing = True then begin
    if (Label1.Font.Color = clRed) and (NewPage <> TabSheet11) then begin
      AllowChange := False;
      PageControl2.Pages[1].Show;
      NotOKMsgs;
    end;
  end;
end;

procedure TForm2.GetTempMailStrs;
begin
  Form4.ListBox1.Items[0] := Form4.Edit2.Text;
  Form4.ListBox1.Items[1] := Form4.Edit3.Text;
  Form4.ListBox1.Items[2] := Form4.Edit4.Text;
  Form4.ListBox1.Items[3] := Form4.Edit5.Text;
end;

procedure TForm2.SetTempMailStrs;
begin
  Form4.Edit2.Text := Form4.ListBox1.Items[0];
  Form4.Edit3.Text := Form4.ListBox1.Items[1];
  Form4.Edit4.Text := Form4.ListBox1.Items[2];
  Form4.Edit5.Text := Form4.ListBox1.Items[3];
end;

procedure TForm2.HelpContentsExecute(Sender: TObject);
begin
  if BitBtn3.Visible
    then BitBtn3.Click
    else ShowMessage('Sorry. This is a information page. No help topic to ' +
                     'display.');
end;

procedure TForm2.FormShow(Sender: TObject);
begin
  Memo1.SelStart := 0;
  Memo2.SelStart := 0;
  Memo3.SelStart := 0;

  if (Form1.Showing = False) and
     (PageControl2.Showing = False) and
     (PageControl3.Showing = False)
       then ShowMessage('It''s seemingly your first contact with Cloxten. ' +
                        'Please, take a moment to read some notices. ' +
                        'Thank you for you interesting.');
end;

end.
