{***************************************************************************
               reminder.pas   -  Reminder and notification form.
                             -------------------
    copyright            : (C) 2002 Alberto Lohmann
    email                : lohmann@users.sourceforge.net
    app. url             : http://cloxten.sourceforge.net
    project url          : http://sourceforge.net/projects/cloxten
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************}

// * This file is part of Cloxten program.



unit reminder;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QTypes, QExtCtrls;

type
  TForm3 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Memo1: TMemo;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure ShowEventsAndTasks;
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;
  ShowingNotes: Boolean=False;

implementation

uses optionsform, mainform, mail, forks;

{$R *.xfm}

procedure TForm3.Button1Click(Sender: TObject);
begin
  ShowingNotes := False; { Reset original value. }
  Form3.Hide;
  if (Form3.Tag = 0) and (Form2.CheckBox5.Checked = True)
    then Form1.Close;
end;

procedure TForm3.ShowEventsAndTasks;
begin
  if Form2.CheckBox1.Checked = True then begin
    Form3.Memo1.Lines.Add('Show reminder window.');
    Form3.Memo1.Lines.Add(' ');
  end;
  if Form2.CheckBox2.Checked = True then begin
    if Form2.RadioButton1.Checked = True
      then begin
        Form3.Memo1.Lines.Add('Beep after done.');
        Form3.Memo1.Lines.Add(' ');
      end;
    if Form2.RadioButton2.Checked = True then begin
      Form3.Memo1.Lines.Add('Play file: ');
      Form3.Memo1.Lines.Add(FileToPlay);
      Form3.Memo1.Lines.Add(' ');
    end;
  end;
  if Form2.RadioButton3.Checked = True then begin
    Form3.Memo1.Lines.Add('No task was selected by user.');
    Form3.Memo1.Lines.Add(' ');
  end;
  if Form2.RadioButton4.Checked = True then begin
    Form3.Memo1.Lines.Add('Message to: ' + Form4.Edit2.Text);
    Form3.Memo1.Lines.Add('Subject: ' + Form4.Edit5.Text);
    if ShowingNotes = False then begin
      if Forks.MsgStatus=0
        then Form3.Memo1.Lines.Add('Status: Sent')
        else Form3.Memo1.Lines.Add('Status: Canceled');
    end
    else Form3.Memo1.Lines.Add('Status: To be sent'); { Time's not up.
                                             Message's waiting to be sent. }
    Form3.Memo1.Lines.Add(' ');
  end;
  if Form2.RadioButton5.Checked = True then begin
    Form3.Memo1.Lines.Add('Open/Run file/program: ');
    Form3.Memo1.Lines.Add(FileToRun);
    Form3.Memo1.Lines.Add(' ');
  end;
end;

procedure TForm3.Timer1Timer(Sender: TObject);
begin
  if Timer1.Tag = 1
    then Label1.Caption := 'Auto close in ' + IntToStr(Timer1.Tag) + ' second.'
    else Label1.Caption := 'Auto close in ' + IntToStr(Timer1.Tag) + ' seconds.';
  Timer1.Tag := Timer1.Tag -1;
  if Timer1.Tag = -1
    then begin
      Timer1.Enabled := False;
      Form3.Close;
    end
    else Timer1.Enabled := True;
end;

procedure TForm3.FormShow(Sender: TObject);
begin
  if (Form3.Tag = 0) and (ShowingNotes = False) then begin
    Form3.Timer1.Enabled := False;
    Form3.Label1.Caption := 'Hello from Cloxten.';
    Form3.Caption := 'Cloxten - Reminder';
    Form3.Memo1.Lines.Add(' ');
    Form3.Memo1.Lines.Add('Done.');
  end
  else if (Form3.Tag = 0) and (ShowingNotes = True) then begin
    Form3.Timer1.Enabled := False;
    Form3.Label1.Caption := 'To do list:';
    Form3.Caption := 'Cloxten - Notes';
  end
  else if (Form3.Tag = 1) and (ShowingNotes = False) then begin
    Form3.Label1.Caption := 'Auto close in 15 seconds.';
    Form3.Caption := 'Cloxten - Notes';
    Form3.Timer1.Tag := 14;
    Form3.Timer1.Enabled := True;
  end;
  Form3.Memo1.SelStart := 0; { Up to first line. }
end;

procedure TForm3.FormHide(Sender: TObject);
begin
  Form3.Timer1.Enabled := False;
  Form3.Memo1.Clear;
  if (Form2.CheckBox8.Checked = True) and (Form3.Tag = 1)
    then Form1.WindowState := wsMinimized;
  if (Form2.CheckBox9.Checked = True) and (Form1.Tag = 1)
    then Form1.Timer1.Enabled := True;
end;

end.
