{***************************************************************************
                    mainform.pas   -  Doctor Doc main unit.
                             -------------------
    copyright            : (C) 2002 Alberto Lohmann
    email                : lohmann@users.sourceforge.net
    app. url             : http://cloxten.sourceforge.net
    project url          : http://sourceforge.net/projects/cloxten
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************}

// * This file is part of Cloxten program.



unit mainform;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls, QTypes, QMenus, QCheckLst, QExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    ListBox1: TListBox;
    MainWindow: TMenuItem;
    BasicActions: TMenuItem;
    AdvancedActions: TMenuItem;
    CounterSettings: TMenuItem;
    AlarmSettings: TMenuItem;
    GeneralSettings: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Quit: TMenuItem;
    View: TMenuItem;
    COPYING: TMenuItem;
    ListBox2: TListBox;
    TextBrowser1: TTextBrowser;
    File1: TMenuItem;
    Help: TMenuItem;
    About: TMenuItem;
    Image1: TImage;
    MessageComposer: TMenuItem;
    ListBox3: TListBox;
    ListBox4: TListBox;
    ListBox5: TListBox;
    ListBox6: TListBox;
    ListBox7: TListBox;
    ListBox8: TListBox;
    ListBox9: TListBox;
    ListBox10: TListBox;
    README: TMenuItem;
    procedure MainWindowClick(Sender: TObject);
    procedure BasicActionsClick(Sender: TObject);
    procedure AdvancedActionsClick(Sender: TObject);
    procedure AlarmSettingsClick(Sender: TObject);
    procedure CounterSettingsClick(Sender: TObject);
    procedure GeneralSettingsClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure COPYINGClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MessageComposerClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure READMEClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.MainWindowClick(Sender: TObject);
begin
  TextBrowser1.Text := ListBox1.Items.Text;
end;

procedure TForm1.BasicActionsClick(Sender: TObject);
begin
  TextBrowser1.Text := ListBox3.Items.Text;
end;

procedure TForm1.AdvancedActionsClick(Sender: TObject);
begin
  TextBrowser1.Text := ListBox4.Items.Text;
end;

procedure TForm1.AlarmSettingsClick(Sender: TObject);
begin
  TextBrowser1.Text := ListBox6.Items.Text;
end;

procedure TForm1.CounterSettingsClick(Sender: TObject);
begin
  TextBrowser1.Text := ListBox7.Items.Text;
end;

procedure TForm1.GeneralSettingsClick(Sender: TObject);
begin
  TextBrowser1.Text := ListBox8.Items.Text;
end;

procedure TForm1.QuitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.COPYINGClick(Sender: TObject);
begin
  TextBrowser1.Text := ListBox2.Items.Text;
end;

procedure TForm1.AboutClick(Sender: TObject);
begin
  TextBrowser1.Text := ListBox9.Items.Text;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;
  ConfigDir: String;

begin
  { Save logo file. }
  ConfigDir := GetEnvironmentVariable('HOME') + '/.cloxten';
  if DirectoryExists(ConfigDir) = False then CreateDir(ConfigDir);
  if DirectoryExists(ConfigDir + '/images') = False then begin
    if DirectoryExists(ConfigDir) = False then CreateDir(ConfigDir);
    CreateDir(ConfigDir + '/images');
    Form1.Image1.Picture.SaveToFile(ConfigDir + '/images/logo.png');
  end;

  TextBrowser1.Factory.FilePath.Append(ConfigDir);

  Form1.About.Click;
  { If none of the above args requested, this will be the initial window. }

  for i := 1 to ParamCount do
  begin
    if LowerCase(ParamStr(i)) = '-m' then Form1.MainWindow.Click
    else if LowerCase(ParamStr(i)) = '-b' then Form1.BasicActions.Click
    else if LowerCase(ParamStr(i)) = '-d' then Form1.AdvancedActions.Click
    else if LowerCase(ParamStr(i)) = '-mc' then Form1.MessageComposer.Click
    else if LowerCase(ParamStr(i)) = '-a' then Form1.AlarmSettings.Click
    else if LowerCase(ParamStr(i)) = '-c' then Form1.CounterSettings.Click
    else if LowerCase(ParamStr(i)) = '-g' then Form1.GeneralSettings.Click
    else if LowerCase(ParamStr(i)) = '-cp' then Form1.COPYING.Click;
  end;
end;

procedure TForm1.MessageComposerClick(Sender: TObject);
begin
  TextBrowser1.Text := ListBox5.Items.Text;
end;
 procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);

begin
  { Remove logo file. }
  DeleteFile(GetEnvironmentVariable('HOME') + '/.cloxten/images/logo.png');
  RemoveDir(GetEnvironmentVariable('HOME') + '/.cloxten/images');//if not empty.
end;

 procedure TForm1.READMEClick(Sender: TObject);

begin
  TextBrowser1.Text := ListBox10.Items.Text;
end;



end.
